Lighting System Design UVA - 11400 (LIS /DP)

2024-04-29 13:32

本文主要是介绍Lighting System Design UVA - 11400 (LIS /DP),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目链接:点击打开链接

You are given the task to design a lighting system for a huge conference hall. After doing a lot ofcalculation and sketching, you have figured out the requirements for an energy-efficient design thatcan properly illuminate the entire hall. According to your design, you need lamps of n different powerratings. For some strange current regulation method, all the lamps need to be fed with the sameamount of current. So, each category of lamp has a corresponding voltage rating. Now, you know thenumber of lamps and cost of every single unit of lamp for each category. But the problem is, you areto buy equivalent voltage sources for all the lamp categories. You can buy a single voltage source foreach category (Each source is capable of supplying to infinite number of lamps of its voltage rating.)and complete the design. But the accounts section of your company soon figures out that they mightbe able to reduce the total system cost by eliminating some of the voltage sources and replacing thelamps of that category with higher rating lamps. Certainly you can never replace a lamp by a lowerrating lamp as some portion of the hall might not be illuminated then. You are more concerned aboutmoney-saving than energy-saving. Find the minimum possible cost to design the system.

input

Each case in the input begins with n (1 ≤ n ≤ 1000), denoting the number of categories. Each of thefollowing n lines describes a category. A category is described by 4 integers - V (1 ≤ V ≤ 132000), thevoltage rating, K (1 ≤ K ≤ 1000), the cost of a voltage source of this rating, C (1 ≤ C ≤ 10), the costof a lamp of this rating and L (1 ≤ L ≤ 100), the number of lamps required in this category. The inputterminates with a test case where n = 0. This case should not be processed.

output

For each test case, print the minimum possible cost to design the system

Sample Input

3

100 500 10 20

120 600 8 16

220 400 7 18

0

Sample Output

778

题目大意:

紫书p275

(今天做的都是LIS类型的,特点就是记录前i的状态,从0-i中寻找j,更新从j+1~i的数值+前j的最优值)

设计一个照明系统,一共有n种灯泡(n<=1000)可供选择,不同种类的灯泡有不同的电源,但同一种灯泡可以共用一个电源,每种灯泡用四个数表示:电压值,电源费用,每个灯泡的费用和所有需要灯泡的数量L.由于电压越高效率越高,那么尽量选电压高的,为了节省电源费用,求出最优方案的费用。

ps:这题意真的是挺让人头疼的,上面是紫书上的翻译,我还是在根据自己的理解翻译一下吧:意思是一共有n种灯泡,用哪一种都行,每种可以用一个电源,因为每种的数量不唯一,但这些同种的都可以用一个电源,关键就是这里使得最优的。既然这样那么,对于第i种灯泡,要么全都用,要么都不用,(其实这里指的是换掉以前的灯泡的时候的用法,比如:在第j种到第i种的灯泡中,都换成第k种灯泡,这k中会用同一个电源,而如果只换了一部分,那么相对都换点而言的话,多加了另一种灯泡的电源费用(好拗口))。因为电压高的效率高,所以先以电压从大到小排序,在优化时,进行从低电压往高电压寻找,如果对于相对高的电压更优化,那么就更新。

记dp[i]表示前i种所得出的最小开销,然后从0-i寻找j,让从j~i换为第i种灯泡时的费用,比较是不是更优化,如果是就跟新。则转移方程为:dp[i]=min{dp[j]+(s[i]-s[j])*c[i]+k[i]}其中dp[j]表示前j中的最小花费,s[i]表示前i种灯泡的数量。

记得在记录s[i]时是排序好的

#include <iostream>
#include <bits/stdc++.h>
#define INF 0x3f3f3f3fusing namespace std;struct node
{int v;int k;int c;int l;
} q[1111];
int s[1111];
int dp[1111];
bool cmp(node x,node y)
{return x.v<y.v;
}
int main()
{int n;while(scanf("%d",&n),n){s[0]=0;for(int i=1; i<=n; i++){scanf("%d%d%d%d",&q[i].v,&q[i].k,&q[i].c,&q[i].l);}sort(q+1,q+1+n,cmp);for(int i=1;i<=n;i++){s[i]=s[i-1]+q[i].l;}dp[0]=0;for(int i=1; i<=n; i++){for(int j=0; j<=i; j++){if(j==0)dp[i]=s[i]*q[i].c+q[i].k;elsedp[i]=min(dp[i],dp[j]+(s[i]-s[j])*q[i].c+q[i].k);}}printf("%d\n",dp[n]);}return 0;
}


这篇关于Lighting System Design UVA - 11400 (LIS /DP)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/946220

相关文章

hdu4826(三维DP)

这是一个百度之星的资格赛第四题 题目链接:http://acm.hdu.edu.cn/contests/contest_showproblem.php?pid=1004&cid=500 题意:从左上角的点到右上角的点,每个点只能走一遍,走的方向有三个:向上,向下,向右,求最大值。 咋一看像搜索题,先暴搜,TLE,然后剪枝,还是TLE.然后我就改方法,用DP来做,这题和普通dp相比,多个个向上

hdu1011(背包树形DP)

没有完全理解这题, m个人,攻打一个map,map的入口是1,在攻打某个结点之前要先攻打其他一个结点 dp[i][j]表示m个人攻打以第i个结点为根节点的子树得到的最优解 状态转移dp[i][ j ] = max(dp[i][j], dp[i][k]+dp[t][j-k]),其中t是i结点的子节点 代码如下: #include<iostream>#include<algorithm

hdu4865(概率DP)

题意:已知前一天和今天的天气概率,某天的天气概率和叶子的潮湿程度的概率,n天叶子的湿度,求n天最有可能的天气情况。 思路:概率DP,dp[i][j]表示第i天天气为j的概率,状态转移如下:dp[i][j] = max(dp[i][j, dp[i-1][k]*table2[k][j]*table1[j][col] )  代码如下: #include <stdio.h>#include

usaco 1.1 Broken Necklace(DP)

直接上代码 接触的第一道dp ps.大概的思路就是 先从左往右用一个数组在每个点记下蓝或黑的个数 再从右到左算一遍 最后取出最大的即可 核心语句在于: 如果 str[i] = 'r'  ,   rl[i]=rl[i-1]+1, bl[i]=0 如果 str[i] = 'b' ,  bl[i]=bl[i-1]+1, rl[i]=0 如果 str[i] = 'w',  bl[i]=b

uva 10055 uva 10071 uva 10300(水题两三道)

情歌两三首,水题两三道。 好久没敲代码了为暑假大作战热热身。 uva 10055 Hashmat the Brave Warrior 求俩数相减。 两个debug的地方,一个是longlong,一个是输入顺序。 代码: #include<stdio.h>int main(){long long a, b;//debugwhile(scanf("%lld%lld", &

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

uva 10387 Billiard(简单几何)

题意是一个球从矩形的中点出发,告诉你小球与矩形两条边的碰撞次数与小球回到原点的时间,求小球出发时的角度和小球的速度。 简单的几何问题,小球每与竖边碰撞一次,向右扩展一个相同的矩形;每与横边碰撞一次,向上扩展一个相同的矩形。 可以发现,扩展矩形的路径和在当前矩形中的每一段路径相同,当小球回到出发点时,一条直线的路径刚好经过最后一个扩展矩形的中心点。 最后扩展的路径和横边竖边恰好组成一个直

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

uva 568 Just the Facts(n!打表递推)

题意是求n!的末尾第一个不为0的数字。 不用大数,特别的处理。 代码: #include <stdio.h>const int maxn = 10000 + 1;int f[maxn];int main(){#ifdef LOCALfreopen("in.txt", "r", stdin);#endif // LOCALf[0] = 1;for (int i = 1; i <=